<?php
// Copyright (C) 2010  Juan Valencia <jvalenciae@jveweb.net>
// Todos los derechos reservados.
//
// La redistribución de este script, con o sin modificaciones, es permitida
// dado que las siquientes condiciones sean cumplidas:
//
// 1. Redistribuciones de este script deben retener la noticia de copyright,
//    esta lista de condiciones y la siquiente renuncia.
//
// ESTE SOFTWARE ES PROVISTO POR EL AUTOR ''COMO ES'' Y CUALQUIER GARANTÍA
// EXPRESADA O IMPLÍCITA, INCLUYENDO, PERO NO LIMITADAS A, LAS GARANTÍAS
// IMPLICÍTAS DE COMERCIABILIDAD Y SALUBRIDAD PARA UN PROPÓSITO EN PARTICULAR
// ES RENUNCIADA. EN NINGÚNA EVENTUALIDAD SERÁ EL AUTOR RESPONSABLE POR
// NINGÚN DAÑO DIRECTO, INDIRECTO, INCIDENTAL, ESPECIAL, EJEMPLIFICANTE, O
// CONSECUENCIAL (INCLUYENDO, PERO NO LIMITADO A, PROCURAMIENTO O SUBSTITUCIÓN
// DE BIENES O SERVICIOS; PERDIDA DE USO, DATOS O GANANCIAS; O INTERRUPCIÓN DE
// NEGOCIOS) COMO SEA QUE HAYAN SIDO CAUSADOS Y EN CUALQUIER TEORÍA DE
// RESPONSABILIDAD, YA SEA EN CONTRATO, RESPONSABILIDAD ESTRICTA, O DELITO
// (INCLUYENDO NEGLIGENCIA U OTRA COSA) QUE RESULTE DE CUALQUIER MANERA DE EL
// USO DE ESTE SOFTWARE, AÚN SI SE SABE DE LA POSIBILIDAD DE SEMEJANTE DAÑO.

// crear_previo_cortado()
// $direccion_imagen - La dirección relativa a una imágen existente desde el
//    script
// $previo_ancho - El áncho máximo de la vista previa
// $previo_alto - El alto máximo de la vista previa
// $prefijo - Un prefijo a ser añadido al nombre del archivo original a fin de
//    obtener el nombre que le será dado a la vista previa

function crear_previo_cortado($direccion_imagen, $previo_ancho, $previo_alto, $prefijo) {
    if (!(is_integer($previo_ancho) && $previo_ancho > 0)) {
        echo "El ancho es inválido";
        exit(1);
    }

    if (!(is_integer($previo_alto) && $previo_alto > 0)) {
        echo "El alto es inválido";
        exit(1);
    }
    $extension = pathinfo($direccion_imagen, PATHINFO_EXTENSION);
    switch ($extension) {
        case "jpg":
        case "jpeg":
            $imagen_original = imagecreatefromjpeg($direccion_imagen);
            break;
        case "gif":
            $imagen_original = imagecreatefromgif($direccion_imagen);
            break;
        case "png":
            $imagen_original = imagecreatefrompng($direccion_imagen);
            break;
        default:
            exit(1);
            echo "Tipo de archivo inválido";
            break;
    }
    $original_ancho = imageSX($imagen_original);
    $original_alto = imageSY($imagen_original);
    if ((($original_ancho / $original_alto) - ($previo_ancho / $previo_alto)) == 0) {
        $original_x = 0;
        $original_y = 0;
    }
    if (($original_ancho / $original_alto) > ($previo_ancho / $previo_alto)) {
        $original_y = 0;
        $temporal_ancho = ceil($original_alto * $previo_ancho / $previo_alto);
        $original_x = ceil(($original_ancho - $temporal_ancho) / 2);
        $original_ancho = $temporal_ancho;
    }
    if (($original_ancho / $original_alto) < ($previo_ancho / $previo_alto)) {
        $original_x = 0;
        $temporal_alto = ceil($original_ancho * $previo_alto / $previo_ancho);
        $original_y = ceil(($original_alto - $temporal_alto) / 2);
        $original_alto = $temporal_alto;
    }
    $imagen_destino = ImageCreateTrueColor($previo_ancho, $previo_alto);
    imagecopyresampled($imagen_destino, $imagen_original, 0, 0, $original_x, $original_y, $previo_ancho, $previo_alto, $original_ancho, $original_alto);
    $archivo_destino = pathinfo($direccion_imagen, PATHINFO_DIRNAME) . "/";
    $archivo_destino .= $prefijo . "_" . pathinfo($direccion_imagen, PATHINFO_FILENAME);
    switch ($extension) {
        case "jpg":
        case "jpeg":
            imagejpeg($imagen_destino, $archivo_destino);
            break;
        case "gif":
            imagegif($imagen_destino, $archivo_destino);
            break;
        case "png":
            imagepng($imagen_destino, $archivo_destino);
            break;
    }
    imagedestroy($imagen_destino);
    imagedestroy($imagen_original);
}
?>
